import './patchAnalytics';
import initTcfTracking from './tcf';
import analytics from './segmentWrapper';
import { defaultContextProperties } from './middlewares/source/defaultContextProperties.js';
import { userScreenInfo } from './middlewares/source/userScreenInfo.js';
import { pageReferrer } from './middlewares/source/pageReferrer.js';
import { userTraits } from './middlewares/source/userTraits.js';
import { getUniversalIdAndNotify } from './universalId.js';
import { isClient } from './config.js';
/* Initialize TCF Tracking with Segment */

initTcfTracking();
/* Generate UniversalId if available */

try {
  getUniversalIdAndNotify();
} catch (e) {
  console.error("[segment-wrapper] UniversalID couldn't be initialized");
}

var addMiddlewares = function addMiddlewares() {
  window.analytics.addSourceMiddleware(userTraits);
  window.analytics.addSourceMiddleware(defaultContextProperties);
  window.analytics.addSourceMiddleware(userScreenInfo);
  window.analytics.addSourceMiddleware(pageReferrer);
};
/* Use source middlewares to add functionality */


if (isClient && window.analytics) {
  window.analytics.addSourceMiddleware ? addMiddlewares() : window.analytics.ready(addMiddlewares);
}

export default analytics;
export { getAdobeVisitorData, getAdobeMCVisitorID } from './adobeRepository.js';
export { getUniversalId } from './universalId.js';